#include <assert.h>
#include <stdio.h>
#include <fcntl.h>
#include "thread/h/thread.h"

#define	THR_SUCCEEDED(x)	((x) >= THR_OKAY)

thread_t tfoo, tbar;
tag_t START  = MSG_TAG_USER;
tag_t FIRST  = MSG_TAG_USER+1;
tag_t SECOND = MSG_TAG_USER+2;
tag_t END    = MSG_TAG_USER+3;

static void*
foo(void* arg)
{
    unsigned msg1, msg2;
	thread_t tid;
    tag_t tag;
	int err;


    printf("thread foo with arg %p\n", arg);
    thr_name("foo");

	tid = THR_TID_UNSPEC;
    tag = START;
    msg_recv(&tid, &tag, 0, 0);

    msg1 = 10; msg2 = 20;
	err = msg_send(tbar, FIRST, &msg1, sizeof msg1);
	if( !THR_SUCCEEDED( err ) )
	{
        thr_perror("msg1");
        return 0;
    }
    err = msg_send(tbar, SECOND, &msg2, sizeof msg2);
	if( !THR_SUCCEEDED( err ) )
	{
        thr_perror("msg2");
        return 0;
    }

    return 0;
}

static void*
bar(void* arg)
{
    thread_t frm;
    tag_t    tag;
    unsigned msg;
    unsigned size;
	int err;


    printf("thread bar with arg %p\n", arg);
    thr_name("bar");

	frm = THR_TID_UNSPEC;
    tag = SECOND;
	size = sizeof msg;
	err = msg_poll(&frm, &tag, 1);
    printf("frm=%u, tag=%u\n", frm, tag);
    err = msg_recv(&frm, &tag, &msg, &size);
    printf("frm=%u, tag=%u, msg=%u, size=%u\n", frm, tag, msg, size);

	frm = THR_TID_UNSPEC;
    tag = FIRST;
	size = sizeof msg;
	err = msg_poll(&frm, &tag, 1);
    printf("frm=%u, tag=%u\n", frm, tag);
    err = msg_recv(&frm, &tag, &msg, &size);
    printf("frm=%u, tag=%u, msg=%u, size=%u\n", frm, tag, msg, size);

    return 0;
}

int
main(void)
{
    thr_name("main");

    thr_create(0, 0, foo, 0, 0, &tfoo);
    thr_create(0, 0, bar, 0, 0, &tbar);

    msg_send(tfoo, START, 0, 0);
    thr_join(tbar, 0, 0);
    thr_join(tfoo, 0, 0);

    return 0;
}
