/*
 * Copyright (c) 1996-1999 Barton P. Miller
 * 
 * We provide the Paradyn Parallel Performance Tools (below
 * described as Paradyn") on an AS IS basis, and do not warrant its
 * validity or performance.  We reserve the right to update, modify,
 * or discontinue this software at any time.  We shall have no
 * obligation to supply such updates or modifications or any other
 * form of support to you.
 * 
 * This license is for research uses.  For such uses, there is no
 * charge. We define "research use" to mean you may freely use it
 * inside your organization for whatever purposes you see fit. But you
 * may not re-distribute Paradyn or parts of Paradyn, in any form
 * source or binary (including derivatives), electronic or otherwise,
 * to any other organization or entity without our permission.
 * 
 * (for other uses, please contact us at paradyn@cs.wisc.edu)
 * 
 * All warranties, including without limitation, any warranty of
 * merchantability or fitness for a particular purpose, are hereby
 * excluded.
 * 
 * By your use of Paradyn, you understand and agree that we (or any
 * other person or entity with proprietary rights in Paradyn) are
 * under no obligation to provide either maintenance services,
 * update services, notices of latent defects, or correction of
 * defects for Paradyn.
 * 
 * Even if advised of the possibility of such damages, under no
 * circumstances shall we (or any other person or entity with
 * proprietary rights in the software licensed hereunder) be liable
 * to you or any third party for direct, indirect, or consequential
 * damages of any character regardless of type of action, including,
 * without limitation, loss of profits, loss of use, loss of good
 * will, or computer failure or malfunction.  You agree to indemnify
 * us (and any other person or entity with proprietary rights in the
 * software licensed hereunder) for any and all liability it may
 * incur to third parties resulting from your use of Paradyn.
 */

// $Id: templates.C,v 1.13 2002/12/20 07:50:09 jaw Exp $
// for table visi

#include "common/h/Vector.h"

template class pdvector<unsigned>;

#include "tvFocus.h"
template class pdvector<tvFocus>;

#include "tvMetric.h"
template class pdvector<tvMetric>;

#include "tvCell.h"
template class pdvector<tvCell>;
template class pdvector< pdvector<tvCell> >;

#include "../../../paradyn/src/UIthread/minmax.C"
template unsigned max(const unsigned, const unsigned);
template float max(const float, const float);
template void ipmax(unsigned&, const unsigned);
template void ipmin(int&, const int);
template int min(const int, const int);
template int max(const int, const int);

#if !defined(i386_unknown_nt4_0)

#include "common/src/Dictionary.C"
#include "paradyn/src/UIthread/pdLogo.h"

template class pdpair<string, pdLogo *>;
template class pdpair<string, pdLogo::logoStruct>;

template pdpair<string, pdLogo *> make_pdpair<string, pdLogo *>(const string &, pdLogo * const &);
template pdpair<string, pdLogo::logoStruct> make_pdpair<string, pdLogo::logoStruct>(const string &, const pdLogo::logoStruct &);

template class pdvector<pdpair<string, pdLogo *> >;
template class pdvector<pdpair<string, pdLogo::logoStruct> >;

template class dictionary_hash<string, pdLogo *>;
template class pdvector<dictionary_hash<string, pdLogo *>::entry>;
template class pdvector<pdLogo *>;

template class dictionary_hash<string, pdLogo::logoStruct>;
template class pdvector<dictionary_hash<string, pdLogo::logoStruct>::entry>;
template class pdvector<pdLogo::logoStruct>;

template class pdvector<string>;
template class refCounter<string_ll>;

#endif //!defined(i386_unknown_nt4_0)
